# 功能：订阅光线数据
# 实验：这个实验需要2个掌控板，一个发布光线数据一个订阅光线数据
#           需要先将公共文件中的Iot.py烧录到掌控板
#           订阅的掌控板，收到数据后，将光强信息显示在屏幕上
#           并且让RGB灯随着光强的变化而变化
#注意事项：这个实验需要2个掌控板，这是订阅端代码
#     本实验使用的是OneNet物联网，用户需要注册OneNet账号，添加
#     产品和设备，并将产品设备信息更新到这个示例中      

from mpython import *
from Iot import Iot
from umqtt.simple import MQTTClient
from machine import Pin
import machine
import time
import json  
import network

WIFI_SSID = 'yourSSID'#替换成你的WIFI热点名称
WIFI_PASSWORD = 'yourPASSWD'#替换成你的WIFI热点密码

ONENET_SERVER = "mqtt.heclouds.com"
ONENET_PORT = 6002
ProductID = "your ProductID" #替换成你的OneNet产品ID
DeviceId = "your DeviceId"#替换成你的OneNet设备ID
ApiKey = "your ApiKey="#替换成你的OneNet设备ApiKey

subTopic = 'light'

def connectWIFI():
  station = network.WLAN(network.STA_IF)
  station.active(True)
  station.connect(WIFI_SSID,WIFI_PASSWORD)
  while station.isconnected() == False:
    pass
  print('Connection successful')
  print(station.ifconfig())
  
def sub_cb(topic,msg):
  print((topic,msg))
  if topic == b'light':
    try:
      print(type(msg))
      print("msg=%s"%str(msg))
      light= json.loads(msg)["light"]
      oled.DispChar("接收到对方光强度",0,0)
      oled.DispChar("%s"%str(light),64,16)
      oled.show()
      oled.fill(0)
      v=light//16
      rgb[0] = (v,v,v)
      rgb[1] = (v,v,v)
      rgb[2] = (v,v,v)
      rgb.write()
    except:
      print("error msg:%s"%msg)
  else:
    print("other topic=%s msg=%s"%(topic,msg))

def restart():
  time.sleep(10)
  machine.reset()

oled.DispChar("正在连接网络...",0,0)
oled.show()
oled.fill(0)
connectWIFI()
myIot = Iot(ONENET_SERVER, ProductID, DeviceId, ApiKey)
client = MQTTClient(myIot.client_id, myIot.mqttserver, port = ONENET_PORT, user = myIot.username, password = myIot.password)
client.set_callback(sub_cb)
client.connect()
client.subscribe(subTopic)

while True:
  try:
    client.check_msg()
  except OSError as e:
    restart()